<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @subpackage tools
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: parser.php 491 2008-11-11 14:13:37Z lks $
 */

header('Content-Type: text/html; charset=utf-8');
chdir('../');

/** zengine */
require_once 'zengine/classes/zengine.php';

/** zparser */
require_once 'tools/zparser.php';

zengine::init();

// переименовываем файл
$filename = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'pages.txt';
if (!file_exists($filename)) {
    echo '<pre>Не найден файл pages.txt. Его нужно либо закачать в папку tools, либо изменить
название архивного, убрав в названии файла точку и цифры после txt.</pre>';
    exit;
}
if (strtolower($_SERVER['REQUEST_METHOD']) == 'post') {
    $logs = array();
    $parseFile = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'pages.txt.' . date('YmdHis');
    if (!rename($filename, $parseFile)) {
        $logs[] = 'Не удалось переименовать файл pages.txt';
        $parseFile = $filename;
    }

    $config = new zconfig('parser.ini');

    $parser = new zparser();
    // установка кодировки страницы файла по умолчанию
    $parser->setDefaultCharset($config->get('parser.charset', 'utf-8'));
    // установка фильтра страницы по умолчанию (text2html или asis)
    $parser->setDefaultFilter($config->get('parser.filter', 'ztypo'));
    // установка флага принудительного создания главной страницы, даже если она существует
    $parser->forceIndex((bool) $config->get('parser.forceindex', true));
    // установка флага удаления старого контента
    $parser->deleteOldContent((bool) $config->get('parser.deleteold', true));
    // обработка файла
    $parser->parse($parseFile);
    // сбрасываем кэш меню
    zengine::zsource()->update();
    $logs += $parser->getLog();
    $logs[] = '------------';
    $logs[] = '<a href="' . zengine::getInstance()->getBaseUri() . '">Открыть сайт</a>';

    echo '<pre>' . implode("\r\n", $logs) . '</pre>';
} else {
    ?>
<form method="post">
<input type="submit" value="Начать импорт" />
</form>
    <?php
}
