<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zsidebar.php 497 2008-11-13 07:54:17Z lks $
 */


/**
 * Абстрактный класс для виджетов
 *
 * @package    zengine
 * @subpackage Widgets
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zsidebar
{
    public function __construct ($params = array()) {
    	$this->params = array_merge($this->params, $params);
    }

    /**
     * Добавляет виджет в сайдбар
     *
     * @param string $id
     * @param zwidget $widget
     * @return zsidebar
     */
    public function addWidget (zwidget $widget) {
    	$this->widgets[$widget->getId()] = $widget;
    	return $this;
    }

    /**
     * Удаляет виджет из сайдбара
     *
     * @param string $id
     * @return zsidebar
     */
    public function removeWidget ($id) {
        if (isset($this->widgets[$id])) {
    	   unset($this->widgets[$id]);
        }
    	return $this;
    }

    /**
     * Выводит все виджеты сайдбара
     *
     *
     */
    public function display () {
    	foreach ($this->widgets as $id => $widget) {
    	    /* @var $widget zwidget */
    	    $widget->display($this->params);
    	}
    }

    /**
     * Массив параметров сайдбара
     *
     * @var array
     */
    private $params = array(
        'before_widget' => '<li id="%1$s" class="widget %2$s">',
        'after_widget' => "</li>\n",
        'before_title' => '<h2 class="widgettitle">',
        'after_title' => "</h2>\n",
    );

    /**
     * Виджеты сайдбара
     *
     * @var array
     */
    private $widgets = array();
}
