<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: compactmenu.php 493 2008-11-12 14:20:49Z lks $
 */


/**
 * Выводит компактное меню сайта. Для очень больших сайтов
 *
 * @package    zengine
 * @subpackage zhelper
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper_compactmenu {
    /**
     * Выводим меню.
     *
     * @param string $type Тип меню
     */
    public function compactmenu () {
        $this->nofollow = '';
        if (zengine::config()->get('menu.nofollow')) {
            $this->nofollow = ' rel="nofollow"';
        }
        $this->pagepath = $this->zpage->getPagepath();

        echo '<ul id="menu">';
        $levelmenu = zengine::zsource()->getMenu()->find($this->zpage->getPagepath());
        if (!$levelmenu) {
            $levelmenu = zengine::zsource()->getMenu();
        } elseif (false == $levelmenu->hasSubmenu()) {
            $levelmenu = $levelmenu->getParent();
        }
        $this->displayBreadcrumbs($levelmenu);
        $this->displayItems($levelmenu);
        echo '</ul>';
    }

    /**
     * Выводим путь из хлебных крошек
     *
     * @param zmenu $item
     */
    private function displayBreadcrumbs (zmenu $item) {
        $items = array();
    	while($item->getParent()) {
            if ($this->pagepath == $item->uri) {
                $items[] = '<li class="up current">' . $item->name;
            } else {
                $items[] = '<li class="up"><a href="' . $item->link . '"' . $this->nofollow . '>' . $item->name . '</a>';
            }
            $item = $item->getParent();
    	}

    	if ('/index' != $this->pagepath) {
            $mainpage = zengine::zsource()->getMenu()->find('/index');
            if ($mainpage) {
                $items[] = '<li class="home up"><a href="' . $mainpage->link . '">' . htmlspecialchars($mainpage->name) . '</a></li>';
            }
    	}

        echo implode(array_reverse($items));
    }

    /**
     * Выводим подпункты меню
     *
     * @param zmenu $items
     */
    private function displayItems ($items) {
        foreach ($items as $item) {
            if ($item->nomenuitem) {
                continue;
            }

            if ('/index' == $item->uri) {
                continue;
            }
            if ($this->pagepath == $item->uri) {
                echo '<li class="current">' . $item->name;
            } else {
                echo '<li><a href="' . $item->link . '">' . $item->name . '</a>';
            }
            if ($this->showSubmenu($item) && $item->hasSubmenu()) {
                echo '<ul>';
                $this->displayItems($item);
                echo '</ul>';
            }
            echo '</li>';
        }
    }

    /**
     * Метод проверяет, нужно ли выводить подпункты меню данного пункта
     *
     * @param zmenu $item пункт меню
     * @return boolean
     */
    private function showSubmenu ($item) {
	    if ($item->uri == $this->zpage->getPagepath() || strpos($this->zpage->getPagepath(), $item->uri . '/') === 0) {
	       return true;
	    } else {
	        return false;
	    }
    }

    /**
     * Дополнительные атрибуты к пунктам меню
     *
     * @var string
     */
    private $nofollow;

    /**
     * Путь к текущей странице
     *
     * @var string
     */
    private $pagepath;
}
