<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: pagenavigation.php 234 2008-09-05 03:37:17Z lks $
 */


/**
 * Выводит внутристраничную навигацию
 *
 * @package    zengine
 * @subpackage zhelper
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zhelper_pagenavigation {
    /**
     * Выводит внутристраничную навигацию
     *
     */
    public function pagenavigation ($open = '<div id="navigation"><span>Страницы:</span> ',
            $lineWithLink = '<a href="#link">#number</a>',
            $lineWithoutLink = '#number',
            $close = '</div>',
            $separator = ' | ') {
        $countSubpages = $this->zpage->countSubpages();
        if ($countSubpages <= 1) {
            return;
        }

        echo $open;
        $parts = array();
        for ($i = 1; $i <= $countSubpages; ++$i) {
            $from = array('#link', '#number');
            $to = array($this->zpage->getSubpageLink($i), $i);
            if ($this->zpage->getSubpage() == $i) {
                $parts[] = str_replace($from, $to, $lineWithoutLink);
            } else {
                $parts[] = str_replace($from, $to, $lineWithLink);
            }
        }
        echo implode($separator, $parts);
        echo $close;
	}

    /**
     * Сортирует тэги между собой
     *
     * @param array $left
     * @param array $right
     * @return int
     */
    public function tagcmp ($left, $right) {
        if ($left['count'] == $right['count']) {
            return strcmp($left['name'], $right['name']);
        }
        return ($left['count'] > $right['count'] ? -1 : 1);
    }
}
