<?php
/**
 * Zebrum Lite
 *
 * ЛИЦЕНЗИЯ
 *
 * Этот исходный файл является предметом лицензии, которая включена в данный
 * пакет в файле LICENSE.txt.
 * Она так же доступна через всемирную сеть Интернет по этому URL:
 * http://www.zebrum.ru/license.html
 *
 * @category   zebrum
 * @package    zengine
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 * @version    $Id: zsitemap.php 505 2008-11-13 10:23:20Z lks $
 */


/**
 * Карта сайта в стиле CMSimple
 *
 * @package    zengine
 * @subpackage zmodule
 * @copyright  Copyright (c) 2008 Zebrum.ru
 * @license    http://www.zebrum.ru/license.txt
 */
class zmodule_zsitemap extends zmodule {
    /**
     * Возвращает ссылку на карту сайта
     *
     * @return string
     */
    public function getLink () {
        if (zengine::getInstance()->getFilepath() == '/sitemap') {
            return $this->loadPage()->getMenu();
        }

        return '<a href="' . $this->loadPage()->getLink() .'">' . $this->loadPage()->getMenu() . '</a>';
    }

    /**
     * Возвращает страницу карты сайта в стиле CMSimple
     *
     * @param string $uri запрос к модулю
     * @return zpage
     */
    public function getPage ($uri) {
        /**
         * Создаем страницу с необходимыми нам свойствами
         */
        $zpage = $this->loadPage();

        /**
         * Метод setBody принимает текст уже в конечной кодировке
         */
        $zpage->setBody($this->getBody());
        return $zpage;
    }

    /**
     * Возвращает тело страницы карты сайты
     *
     * @return string
     */
    private function getBody () {
        ob_start();
        echo '<ul class="sitemaplevel1">';
        $this->displayItems(zengine::zsource()->getMenu(), 2);
        echo '</ul>';
        $body = ob_get_contents();
        ob_end_clean();
        return $body;
    }

    /**
     * Выводим подпункты меню
     *
     * @param zmenu $items
     * @param int $level
     */
    private function displayItems ($items, $level) {
        foreach ($items as $item) {
            $suffix = '';
            if ($item->hasSubmenu()) {
                $suffix = 's';
            }
            echo '<li class="doc' . $suffix . '"><a href="' . $item->link . '">' . $item->name . '</a>';
            if ($item->hasSubmenu()) {
                echo '<ul class="sitemaplevel' . $level . '">';
                $this->displayItems($item, $level + 1);
                echo '</ul>';
            }
            echo '</li>';
        }
    }

    /**
     * Возвращает объект страницы карты сайта без содержимого
     *
     * @return zpage
     */
    private function loadPage () {
        if (isset($this->_zpage)) {
            return $this->_zpage;
        }
        $properties = array();
        $properties['menu'] = $properties['breadcrumb'] = $properties['title'] = $this->getParam('title', 'Site map');
        $properties['pagepath'] = '/sitemap';
        $properties['filter'] = 'asis';
        $this->_zpage = zpage::createPage($properties);
        return $this->_zpage;
    }

    /**
     * Объект загруженной страницы
     *
     * @var zpage
     */
    private $_zpage;
}